import java.awt.FileDialog;
import java.awt.Point;
import java.awt.Toolkit;
import java.awt.datatransfer.Clipboard;
import java.awt.datatransfer.DataFlavor;
import java.awt.datatransfer.Transferable;
import java.awt.datatransfer.UnsupportedFlavorException;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.awt.event.MouseMotionListener;
import java.awt.image.BufferedImage;
import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.text.SimpleDateFormat;
import java.util.Date;

import javax.imageio.ImageIO;
import javax.swing.Box;
import javax.swing.ImageIcon;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JMenu;
import javax.swing.JMenuBar;
import javax.swing.JMenuItem;
import javax.swing.JOptionPane;
import javax.swing.KeyStroke;



/**
 * @author Nick Kraayenbrink / Barubary / Akatonbo
 * @since 19 dec 2007
 * @version 2.3
 */
public class IconMaker implements ActionListener, MouseListener, MouseMotionListener, KeyListener{
	
	private BufferedImage image = null;	
	private BufferedImage middleimage = null;
	private Point middleimageLoc = new Point(0,0);
	private int middleimageZoom = 2;
	private String imagestring = ""; // the string to be placed on the icon
	private String imagename = ""; // the filename of the image if it's not copied from the clipboard
	private final Clipboard sysclip = Toolkit.getDefaultToolkit().getSystemClipboard();
	private float alpha = 1;
	private int transpCol = 0xFF00FF;
	private boolean hasTranspBG = true;
	
	// initialize frame and label
	private JFrame frame = new JFrame("Icon Maker V3 - By Barubary");
	private JLabel label = new JLabel();
	
	private JLabel templabel = new JLabel();

	// initialize the menu-components
	private JMenuBar menubar = new JMenuBar();
	private JMenu filemenu = new JMenu("File");
	private JMenuItem loaditm = new JMenuItem("Load Icon");
	private JMenuItem saveitm = new JMenuItem("Save Icon");
	private JMenuItem copyitm = new JMenuItem("Copy Icon");
	private JMenuItem exititm = new JMenuItem("Exit");
	
	private JMenuItem newitm = new JMenuItem("New Icon");
	
	private JMenu textmenu = new JMenu("Text");
	private JMenuItem addtextitm = new JMenuItem("Add Text");
	private JMenuItem cleartextitm = new JMenuItem("Clear Text");
	
	private JMenu imagemenu = new JMenu("Image");
	private JMenuItem centerimitm = new JMenuItem("Center Image");
	private JMenuItem pasteimitm = new JMenuItem("Paste Image");
	private JMenuItem clearimitm = new JMenuItem("Clear Image");
	private JMenuItem putimitm = new JMenuItem("Place Image");
	private JMenu zoomitmmenu = new JMenu("Zoom");
	private JMenuItem zoom1 = new JMenuItem("100%");
	private JMenuItem zoom2 = new JMenuItem("200%");
	private JMenu transpMenu = new JMenu("Transparency");
	private JMenu bgcolMenu = new JMenu("Background");
	private JMenuItem bgmag = new JMenuItem("Pure Magenta");
	private JMenuItem bgwht = new JMenuItem("Pure White");
	private JMenuItem bgblk = new JMenuItem("Pure Black");
	private JMenuItem bgTL = new JMenuItem("Top-Left pixel");
	private JMenuItem bgnone = new JMenuItem("No Background");
	private JMenuItem bgcus = new JMenuItem("Custom colour");
	private JMenu alphaMenu = new JMenu("Opacity");
	private JMenuItem alpha100 = new JMenuItem("100%");
	private JMenuItem alpha75 = new JMenuItem("75%");
	private JMenuItem alpha50 = new JMenuItem("50%");
	private JMenuItem alpha25 = new JMenuItem("25%");
	private JMenuItem alphacus = new JMenuItem("Custom");
	
	
	private JLabel zoomLabel = new JLabel("Zoom: 1x");
	
	private enum TYPE {
		SHEET,
		GAME
	}
	private enum SECTION {
		SPRITE,
		MODEL,
		TEXTURE
	}
	
	private TYPE icontype;
	private SECTION iconsection;
	
	// nothing important, just to make my life easier when I want to export this program
	// TODO: flip value to true when exporting
	private boolean exported = true;
	
	public static void main(String[] args){
		new IconMaker();
	}
	
	public IconMaker(){
		// set default size of the JFrame
		frame.setSize(550,550);
		// I want to manage the layout
		frame.setLayout(null);
		// close on exit
		frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE); 
		
		// initialize the label
		label.setSize(100,100);
		label.setLocation(5,5);
		frame.add(label);
		label.setVisible(true);
		
		templabel.setLocation(300,300);
		frame.add(templabel);
		
		// initialize the menubar
		initMenuBar();
		
		label.addMouseListener(this);
		label.addMouseMotionListener(this);
		frame.addKeyListener(this);
		
		frame.setVisible(true);
	}
	
	/**
	 * initializes the menubar
	 */
	private void initMenuBar(){
		
		filemenu.add(newitm);
		filemenu.add(loaditm);
		filemenu.add(saveitm);
		filemenu.addSeparator();
		filemenu.add(copyitm);
		filemenu.addSeparator();
		filemenu.add(exititm);
		newitm.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_N, ActionEvent.CTRL_MASK));
		loaditm.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_O,ActionEvent.CTRL_MASK));
		saveitm.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_S,ActionEvent.CTRL_MASK));
		exititm.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_Q,ActionEvent.CTRL_MASK));
		copyitm.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_C,ActionEvent.CTRL_MASK));
		newitm.addActionListener(this);
		loaditm.addActionListener(this);
		saveitm.addActionListener(this);
		exititm.addActionListener(this);
		copyitm.addActionListener(this);
		
		textmenu.add(addtextitm);
		textmenu.add(cleartextitm);
		addtextitm.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_A, ActionEvent.ALT_MASK));
		cleartextitm.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_D, ActionEvent.ALT_MASK));
		addtextitm.addActionListener(this);
		cleartextitm.addActionListener(this);
		
		imagemenu.add(pasteimitm);
		imagemenu.add(clearimitm);
		imagemenu.add(centerimitm);
		imagemenu.add(putimitm);	
		zoomitmmenu.add(zoom1);
		zoomitmmenu.add(zoom2);
		imagemenu.add(zoomitmmenu);
		bgcolMenu.add(bgmag);
		bgcolMenu.add(bgwht);
		bgcolMenu.add(bgblk);
		bgcolMenu.add(bgTL);
		bgcolMenu.add(bgnone);
		bgcolMenu.add(bgcus);
		transpMenu.add(bgcolMenu);
		alphaMenu.add(alpha100);
		alphaMenu.add(alpha75);
		alphaMenu.add(alpha50);
		alphaMenu.add(alpha25);
		alphaMenu.add(alphacus);
		transpMenu.add(alphaMenu);
		imagemenu.add(transpMenu);
		pasteimitm.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_V, ActionEvent.CTRL_MASK));
		clearimitm.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_D, ActionEvent.CTRL_MASK));
		centerimitm.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_M, ActionEvent.CTRL_MASK));
		putimitm.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_ENTER, ActionEvent.CTRL_MASK));
		centerimitm.addActionListener(this);
		pasteimitm.addActionListener(this);
		clearimitm.addActionListener(this);
		putimitm.addActionListener(this);
		zoom1.addActionListener(this);
		zoom2.addActionListener(this);
		bgmag.addActionListener(this);
		bgwht.addActionListener(this);
		bgblk.addActionListener(this);
		bgTL.addActionListener(this);
		bgnone.addActionListener(this);
		bgcus.addActionListener(this);
		alpha100.addActionListener(this);
		alpha75.addActionListener(this);
		alpha50.addActionListener(this);
		alpha25.addActionListener(this);
		alphacus.addActionListener(this);
		
		menubar.add(filemenu);
		menubar.add(textmenu);
		menubar.add(imagemenu);
		menubar.add(Box.createHorizontalGlue());
		menubar.add(zoomLabel);
		
		frame.setJMenuBar(menubar);
	}

	
	/**
	 * Show two dialogs to determine what kind of new icon should be made.
	 * Make a new icon when both dialogs have been filled and not quit with cancel or the X button.
	 */
	private void newIconDialog(){
		// select section
		Object[] secPossibl = SECTION.values();
		Object section = JOptionPane.showInputDialog(this.frame, 
									"Choose to which section the icon belongs.\n ", 
									"Determine Section.", 
									JOptionPane.QUESTION_MESSAGE, 
									null, 
									secPossibl, 
									secPossibl[0]);
		if(section == null)
			return;
		// select type
		Object[] typePossibl = TYPE.values();
		Object type = JOptionPane.showInputDialog(this.frame, 
									"Choose what kind of icon should be made.\n ", 
									"Determine Type.",
									JOptionPane.QUESTION_MESSAGE, 
									null, 
									typePossibl, 
									typePossibl[0]);
		if(type == null)
			return;
		this.newIcon((TYPE)type, (SECTION)section);
	}
	
	
	/**
	 * Creates a new icon.
	 * @param type the type of the icon to be created
	 */
	private void newIcon(TYPE type, SECTION section){
		try{
			image = getImage(getIconFilePrefix(type, section)+"total.png");
			this.icontype = type;
			this.iconsection = section;
			resetLabelIcon();
		} catch(Exception ex){
			showError("Couldn't find the default icon.");
			ex.printStackTrace();
			printError(ex.getMessage());
		}
	}
	
	/**
	 * Gets the path and prefix of an icon part file
	 * @param type Of which type the icon is
	 * @param section In which section the icon belongs
	 */
	private String getIconFilePrefix(TYPE type, SECTION section){
		StringBuffer sbuf = new StringBuffer("iconData/bases/");
		String typestr = type.toString().toLowerCase();
		String secstr = section.toString().toLowerCase();
		sbuf.append(typestr);
		sbuf.append("/");
		sbuf.append(secstr);
		sbuf.append("/");
		sbuf.append(typestr);
		sbuf.append("_");
		sbuf.append(secstr);
		sbuf.append("_");
		return sbuf.toString();
	}
	
	/**
	 * sets the text for the Icon
	 */
	private void setIconText(){
		imagestring = JOptionPane.showInputDialog(frame,"Enter the title of the Icon:",imagestring);
		if(imagestring==null)
			return;
		resetLabelIcon();
	}
	
	/**
	 * clears the text
	 */
	private void clearText(){
		try{
			BufferedImage bg = null;
			int x=0, y=0;
			switch(icontype){
				case SHEET:
					bg = getImage(getIconFilePrefix(icontype, iconsection)+"textbg.png");
					x=5;
					y=4;
					break;
				case GAME:
					bg = getImage(getIconFilePrefix(icontype, iconsection)+"textbg.png");
					x=4;
					y=4;
					break;
				default: 
					bg = null;
					break;
				
			}
			image = combine(image, bg, x, y, 1);
			imagestring = "";
			resetLabelIcon();
		} catch(Exception ioex){
			showError("Some error occurred. Contact me (Barubary) if you think it wasn't your fault.");
			printError(ioex.getMessage());
		}
	}
	
	private void clearImage(){
		if(middleimage != null){
			middleimage = null;
			resetLabelIcon();
		} else {
			newIcon(icontype, iconsection);
		}
	}
	
	/**
	 * centers the middle image
	 */
	private void centerImage(){
		if(image != null && middleimage != null){
			BufferedImage zoomedMImage = zoomTo(middleimage, middleimageZoom);
			int mimgx = image.getWidth()/2 - zoomedMImage.getWidth()/2;
			int mimgy = 0;
			int bartop = 0, barbot = 0;
			switch(icontype){
			case SHEET:
				bartop = 31;
				barbot = 5;
				break;
			case GAME:
				bartop = 23;
				barbot = 4;
				break;
			}
			mimgy = (image.getHeight()-bartop-barbot)/2 - zoomedMImage.getHeight()/2 + bartop;
			middleimageLoc.setLocation(mimgx, mimgy);
			resetLabelIcon();
		}
	}
	
	private BufferedImage getImage(String filedir){
		try{
			if(!exported)
				return ImageIO.read(new File(filedir));
			else
				return ImageIO.read(this.getClass().getResource("/"+filedir));
		} catch(Exception ex){
			showError("Couldn't find one of the required images: '"+filedir+"'. Please re-download, or contact me (Barubary).");
		}
		return null;
	}
	
	
	/**
	 * set this object onto the clipboard
	 */
	private void copy(){
		sysclip.setContents(new ImageData(addTextTo(addMiddleImageTo(image))), null);
	}
	
	/**
	 * try to get an image from the clipboard
	 */
	private void pasteImage(){
		BufferedImage tempmiddleimage = null;
		try{
			Transferable clipEntry = sysclip.getContents(null);
			
			if(clipEntry.isDataFlavorSupported(DataFlavor.imageFlavor)){
				tempmiddleimage = (BufferedImage)clipEntry.getTransferData(DataFlavor.imageFlavor);
				
			}
		} catch(IOException ioex){
			showError("Can't read from Clipboard");
			ioex.printStackTrace();
		} catch(UnsupportedFlavorException ufex){
			//can't happen, as we already checked that
			//System.out.println("guess not...");
			showError("Clipboard data isn't an image.");
			ufex.printStackTrace();
		}
		if(tempmiddleimage==null){
			showError("Clipboard data isn't an image.");
			return;
		}
		middleimageZoom = 1;
		zoomLabel.setText("Zoom: 1x");
		middleimage = tempmiddleimage;
		centerImage();
		// resetting icon already done by centerImage
		//resetLabelIcon();
		
	}
	
	/**
	 * Loads an icon from a file
	 */
	private void load(){
		FileDialog fdiag = new FileDialog(frame,"Open File",FileDialog.LOAD);
		
		fdiag.setVisible(true);
		BufferedImage tempimage = null;
		String fname = fdiag.getFile();
		try{
			tempimage = ImageIO.read(new File(fdiag.getDirectory()+fname));
		}catch(FileNotFoundException fnfe){
			showError("Couldn't find the specified file");
		}catch(IOException ioe){
			showError("The specified file isn't a supported image, or is corrupted");
			return;
		}
		if(tempimage==null)
			showError("The specified file isn't an image");
		else{
			image = tempimage;
			imagename = fname;
			resetLabelIcon();			
		}
		
	}
	
	/**
	 * Tries to save the Icon
	 */
	private void save(){
		if(image==null){
			showError("There is no icon to be saved");
			return;
		}
		FileDialog fdiag = new FileDialog(frame,"Save File",FileDialog.SAVE);
		fdiag.setFile(imagename);
		fdiag.setVisible(true);
		String fname = fdiag.getFile();
		if(fname==null)
			return;
		String fdir = fdiag.getDirectory();

		// disregard overwrites, as the FileDialog already takes care of that (ie: always overwrite if we get here)
		try{
			// check if the user already specified the extension
			String[] fnameparts = fname.split("\\.");
			String ext;
			if(fnameparts.length==0){
				ext = "png";
				fname+=".png";
			} else {
				ext = fnameparts[fnameparts.length-1];
			}
			// if not (or specified an invalid one), the default is .png
			if(fnameparts.length==1 || !(ext.equals("png") || ext.equals("gif") || ext.equals("bmp"))){
				ext = "png";
				fname +=".png";
			}
			// try to write
			ImageIO.write(addTextTo(addMiddleImageTo(image)), ext, new File(fdir+fname));
			
		}catch(IOException ioe){
			showError("Couldn't write to the specified directory");
			ioe.printStackTrace();
		}
	}
	
	
	/**
	 * 'permanently' puts the middle image onto the image
	 */
	private void putImage(){
		image = addMiddleImageTo(image);
		middleimage = null;
		resetLabelIcon();
	}
	
	/**
	 * Add the text to the icon, and returns an edited copy of the icon
	 * @return a BufferedImage with as background the Icon, and the text added as foreground (font: Verdana; size: 7; colour: #E8E8E8) 
	 */
	private BufferedImage addTextTo(BufferedImage imIn){
		/* 
		 * the maximum width the text can have, the maximum amount of lines, 
		 * and the index of the line of the top font-pixel if there's only one line
		 */
		int maxwidth = 0, 
			maxlines = 0,
			lineindex = 0;
		/*
		 *  the index of the top line the font should be on if it goes on two lines
		 */
		int[] twolineheights = {0,0}; 
		switch(icontype){
			case SHEET:
				maxwidth = 96;
				maxlines = 2;
				lineindex = 8;
				twolineheights[0] = 2;
				twolineheights[1] = 13;
				break;
			case GAME:
				maxwidth = 160;
				maxlines = 1;
				lineindex = 4;
				break;
			default:
				showError("A bug has occurred. Don't ask me how.");
				return imIn;
		}
		
		// stop trying if there's no text
		if(imagestring == null || imagestring.equals(""))
			return imIn;
		
		char[] chars = imagestring.toCharArray();
		// convert the characters to widths (of the corresponding images)
		int[] widths = getWidths(chars);
		
		// stop if there was an invalid character
		if(widths==null)
			return imIn;
		
		// add 'em up
		int charswidth = 0;
		for(int i:widths)
			charswidth += i;
		
		
		/* 
		 * if the width is larger than twice the maximum width 
		 * (minus 3 pixels from the width for a whitespace), or larger than 
		 * twice the maximum width and the string contains no 
		 * whitespace, stop trying
		 */
		if(charswidth>(2*maxwidth+3) || (charswidth>(2*maxwidth) && imagestring.indexOf((int)' ')==-1)){
			showError("The string is too long");
			return imIn;
		}
		/*
		 * also stop trying if the width is larger than the maximum width, 
		 * and you can only use one line
		 */
		if(charswidth>maxwidth && maxlines==1){
			showError("The string is too long");
			return imIn;
		}

		// it's easy if it fits on one line
		if(charswidth<=maxwidth)
			return putOnOneLine(imIn, chars, lineindex, charswidth);
		
		// try to find the index of the whitespace closest to the middle, 
		// and check if it's possible on two lines. if so, call putOnOneLine twice, return the original image otherwise
		
		// where's the middle?
		int halfwidth = (int)Math.ceil(charswidth/2);
		int currWidth = 0;
		int idx = 0;
		// at the end idx is the index of the first character that needs to be on the second line if the string would be split up in two
		while(currWidth<halfwidth){
			currWidth+=widths[idx++];
		}
		
		// we know there's a whitespace somewhere, but we need to find the one closest to the middle
		int middle = imagestring.length()/2;
		String 	leftstr = imagestring.substring(0,middle), 
				rightstr = imagestring.substring(middle),
				leftrevstr = reverse(leftstr);
		// find the two (or the) whitespace characters closest to the middle; one on the left side and one on the right side
		int leftidx = leftrevstr.indexOf((int)' '),
			rightidx = rightstr.indexOf((int)' ');
		
		int actualindex = 0;
		if(leftidx>rightidx || leftidx==-1){
			actualindex = rightidx+middle;
		} else {
			actualindex = middle-leftidx;
		}
		// everything left of actualindex goes on the top line, everything right of actualindex on the bottom one
		String 	topstr = imagestring.substring(0,actualindex),
				bottomstr = imagestring.substring(actualindex+1);
		char[] 	top = topstr.toCharArray(),
				bottom = bottomstr.toCharArray();
		
		// check if the widths don't exceed the maximum
		int topwidth = 0, bottomwidth = 0;
		for(int w:getWidths(top))
			topwidth += w;
		for(int w:getWidths(bottom))
			bottomwidth += w;
		if(topwidth>maxwidth || bottomwidth>maxwidth){
			showError("The String is too long");
			return imIn;
		}
		// put the text on the lines
		BufferedImage imOut = putOnOneLine(imIn, top, twolineheights[0], topwidth);
		imOut = putOnOneLine(imOut, bottom, twolineheights[1], bottomwidth);
		
		return imOut;
	}
	
	/**
	 * Reverse a String
	 * @param str the String to be reversed
	 * @return a reversed version of the String
	 */
	private String reverse(String str){
		StringBuffer sbuf = new StringBuffer();
		for(int i=0; i<str.length(); i++){
			sbuf.append(str.charAt(str.length()-i-1));
		}
		return sbuf.toString();
	}
	
	/**
	 * Puts the given char-array on the imageIn, and returns a copy of the imageIn, 
	 * with the given String(char[]) added on top
	 * @param imageIn the image the text needs to be put on to
	 * @param line the char-array to be put on the image
	 * @param index the index of the line of the top pixel of the font
	 * @param charwidth the width of the char[] if converted to images (to save time)
	 * @return a copy of image, with the given text added. assumes the text fits
	 */
	private BufferedImage putOnOneLine(BufferedImage imageIn, char[] line, int index, int charwidth){
		BufferedImage text = new BufferedImage(charwidth, 14, BufferedImage.TYPE_INT_ARGB);
		
		// add the characters onto text
		int currX = 0;
		BufferedImage tempIm = null;
		for(char c:line){
			tempIm = getCharImage(c);
			text = combine(text,tempIm,currX,0,1,0xFFFFFF);
			currX += tempIm.getWidth();
		}
		
		int leftx = (imageIn.getWidth()- text.getWidth())/2;
		
		// copy imageIn
		BufferedImage imOut = new BufferedImage(imageIn.getWidth(), imageIn.getHeight(), BufferedImage.TYPE_INT_ARGB);
		imOut = combine(imOut, imageIn, 0, 0,1);
		
		// add the text onto the copy
		imOut = combine(imOut, text, leftx, index, 1, 0x000000);
			
		// return the all-in-one image
		return imOut;
	}
	
	/**
	 * Combines two bufferedImage into one, while ignoring the background-colours
	 * @param background the background of the new image
	 * @param foreground the foreground of the new image
	 * @param x the x-position of the foreground
	 * @param y the y-position of the foreground
	 * @param alpha the opacity of the foreground
	 * @return the foreground added to the background at (x,y), retaining transparency
	 */
	private BufferedImage combine(BufferedImage background, BufferedImage foreground, int x, int y, float alpha){
		
		// copy the background;
		BufferedImage retBG = zoomTo(background, 1);
		int currARGB = 0, currbgARGB; // dummies
		// for each pixel in the foreground
		for(int i=x; i<(foreground.getWidth()+x); i++){
			for(int j=y; j<(foreground.getHeight()+y); j++){
				try{
					// get the ARGB-value of the fore- and background
					currARGB = foreground.getRGB(i-x, j-y);
					currbgARGB = background.getRGB(i, j);
					// combine the values and put it in the copy of the background
					if(alpha!=1f)
						retBG.setRGB(i,j, combinePixels(currbgARGB, currARGB, alpha));
					else
						retBG.setRGB(i,j,currARGB&0x00FFFFFF+0xFF000000); // make sure the original alpha mask is ignored
				} catch(Exception ignore){} // don't draw outside the icon, and don't try getting a colour from outside the image
			}
		}
		return retBG;
	}
	
	/**
	 * Combines two bufferedImage into one
	 * @param background the background of the new image
	 * @param foreground the foreground of the new image
	 * @param x the x-position of the foreground
	 * @param y the y-position of the foreground
	 * @param alpha the opacity of the foreground
	 * @param bgcolour the colour of the foreground that needs to be transparent
	 * @return the foreground added to the background at (x,y), retaining transparency
	 */
	private BufferedImage combine(BufferedImage background, BufferedImage foreground, int x, int y, float alpha, int bgcolour){
		if(alpha == 1f) // use another method if the opacity is 100% anyway
			return combine(bgcolour, background, foreground, x, y);
		// copy the background;
		BufferedImage retBG = zoomTo(background, 1);
		if(alpha == 0f) // we can just return the background if the opacity is 0 somehow
			return retBG;
		
		int currARGB = 0, currbgARGB = 0; // dummies
		// for each pixel in the foreground
		for(int i=x; i<(foreground.getWidth()+x); i++){
			for(int j=y; j<(foreground.getHeight()+y); j++){
				try{
					// get the ARGB-value of the fore- and background
					currARGB = foreground.getRGB(i-x, j-y);
					currbgARGB = background.getRGB(i, j);
					// check if the current value should be transparent
					float localalpha = alpha;
					if((currARGB & 0x00FFFFFF)== bgcolour){
						localalpha = 0f;
					}
					// combine the values and put it in the copy of the background
					retBG.setRGB(i,j, combinePixels(currbgARGB, currARGB, localalpha));
				} catch(Exception ignore){} // don't draw outside the icon, and don't try getting a colour from outside the image
			}
		}
		return retBG;
	}
	
	/**
	 * Combines two bufferedImage into one, while ignoring alpha-blending
	 * @param bgcolour the colour of the foreground that needs to be transparent
	 * @param background the background of the new image
	 * @param foreground the foreground of the new image
	 * @param x the x-position of the foreground
	 * @param y the y-position of the foreground
	 * @return the foreground added to the background at (x,y), retaining transparency
	 */
	private BufferedImage combine(int bgcolour, BufferedImage background, BufferedImage foreground, int x, int y){
		// copy the background;
		BufferedImage retBG = zoomTo(background, 1);
		
		int currARGB = 0; // dummy
		// for each pixel in the foreground
		for(int i=x; i<(foreground.getWidth()+x); i++){
			for(int j=y; j<(foreground.getHeight()+y); j++){
				try{
					// get the ARGB-value of the foreground
					currARGB = foreground.getRGB(i-x, j-y);

					// only paste the pixel if it shouldn't be transparent
					if((currARGB&0x00FFFFFF) != bgcolour)
						retBG.setRGB(i,j, currARGB);
						
				} catch(Exception ignore){} // don't draw outside the icon, and don't try getting a colour from outside the image
			}
		}
		return retBG;
	}
	
	/**
	 * Combine two pixels with an alpha mask (ignore alpha-values in the ARGB-values)
	 * @param bg the background-pixel (ARGB-value)
	 * @param fg the foreground-pixel (ARGB-value)
	 * @param alpha the opacity of the foreground-pixel
	 * @return an ARGB-value corresponding to the 'combined' pixel
	 */
	private int combinePixels(int bg, int fg, float alpha){
		// ignore alpha masks already in the BufferedImage, and put the R, G and B values of fg and bg in arrays
		int[] fgrgb = {(fg & 0x00FF0000) >> 16,
						(fg & 0x0000FF00) >> 8,
						(fg & 0x000000FF)};
		int[] bgrgb = {(bg & 0x00FF0000) >> 16,
						(bg & 0x0000FF00) >> 8,
						(bg & 0x000000FF)};
		// combine the two arrays (weighted averages)
		int[] newrgb = {Math.round(alpha*fgrgb[0]+(1-alpha)*bgrgb[0]),
						Math.round(alpha*fgrgb[1]+(1-alpha)*bgrgb[1]),
						Math.round(alpha*fgrgb[2]+(1-alpha)*bgrgb[2])};
		// return the combined ARGB-value (with 100% opacity)
		String newHex = "FF"+dec2hex(newrgb[0])+dec2hex(newrgb[1])+dec2hex(newrgb[2]);
		return hex2dec(newHex);
	}

	
	/**
	 * Converts a given char[] to an int[] of the same length, where each element in the int[] is the width of the image corresponding to the corresponding element in the char[] 
	 * @param chars the characters of the string we would like to know the width of
	 * @return an int[] with widths, or null if there was an invalid character
	 */
	private int[] getWidths(char[] chars){
		int[] widths = new int[chars.length];
		BufferedImage currIm = null;
		for(int i=0; i<chars.length; i++){
			currIm = getCharImage(chars[i]);
			// stop if any of the characters are invalid
			if(currIm==null)
				return null;
			widths[i] = currIm.getWidth();
		}
		
		return widths;
	}
	
	/**
	 * Tries to get the image of the given character
	 * @param c the character we want the image from
	 * @return the image of the character, or null if an exception occurred, or we didn't find it
	 */
	private BufferedImage getCharImage(char c){
		BufferedImage retIm = null;
		try{
			retIm = getImage("iconData/font/"+(int)c+".png");
			
		} catch (Exception ex){
			retIm = null;
		}
		if(retIm==null){
			showError("You entered the character "+c+",but this program doesn't support it.");
			return null;
		} else {
			return retIm;
		}
	}
	
	/**
	 * Adds the middle image 'middleimage' onto the given image, and cuts off the edges so that it won't cross the lines of the icon
	 * @param bg the icon (with or without text)
	 * @return a copy of the icon with an image in the 'middle' (area below the text)
	 */
	private BufferedImage addMiddleImageTo(BufferedImage bgIn){
		BufferedImage bg = zoomTo(bgIn,1);
		if(middleimage==null){
			return bg;
		}
		try{
			
			
			if(hasTranspBG)
				bg = combine(bg, zoomTo(middleimage, middleimageZoom), middleimageLoc.x, middleimageLoc.y, alpha, transpCol);
			else
				bg = combine(bg, zoomTo(middleimage, middleimageZoom), middleimageLoc.x, middleimageLoc.y, alpha);
		
			BufferedImage edge = null;

			edge = getImage(getIconFilePrefix(icontype, iconsection)+"edge.png");

			return combine(bg, edge, 0, 0, 1, 0xFFFFFF);
		} catch(Exception ex){
			ex.printStackTrace();
			return image;
			
		}
	}
	
	/**
	 * zooms in
	 * @param imIn the image that needs to be zoomed in
	 * @param zoom the desired zoom of the image
	 * @returns a copy of imIn, but zoomed in
	 */
	private BufferedImage zoomTo(BufferedImage imIn, int zoom){
		BufferedImage imOut = new BufferedImage(imIn.getWidth()*zoom, imIn.getHeight()*zoom, BufferedImage.TYPE_INT_ARGB);
		for(int i=0; i<imOut.getWidth(); i++){
			for(int j=0; j<imOut.getHeight(); j++){
				int currRGB = imIn.getRGB(i/zoom,j/zoom);
				imOut.setRGB(i,j,currRGB);
			}
		}
		return imOut;
	}
	
	
	
	private void resetLabelIcon(){
		if(image==null){
			showError("No Icon loaded");
			return;
		}
		label.setLocation(frame.getWidth()/2 - image.getWidth()/2,frame.getHeight()/2-image.getHeight()/2-50);
		label.setSize(image.getWidth(), image.getHeight());
		label.setIcon(new ImageIcon(addTextTo(addMiddleImageTo(image))));
	}
	
	private void increaseZoom(){
		if(image==null || middleimage==null){
			showError("No image to zoom in");
			return;
		}
		if(middleimageZoom==2){
			showError("Zooming in any further is prohibited.");
			return;
		}
		int newx = middleimageLoc.x - middleimage.getWidth()/2;
		int newy = middleimageLoc.y - middleimage.getHeight()/2;
		middleimageLoc.setLocation(newx, newy);
		middleimageZoom = 2;
		zoomLabel.setText("Zoom: 2x");
		resetLabelIcon();
	}
	
	private void decreaseZoom(){
		if(image==null || middleimage==null){
			showError("No image to zoom out");
			return;
		}
		if(middleimageZoom==1){
			showError("You can't zoom out any further");
			return;
		}
		int newx = middleimageLoc.x + middleimage.getWidth()/2;
		int newy = middleimageLoc.y + middleimage.getHeight()/2;
		middleimageLoc.setLocation(newx, newy);
		middleimageZoom = 1;
		zoomLabel.setText("Zoom: 1x");
		resetLabelIcon();
	}
	
	
	private void setTranspBGColour(){
		String transpRGB = "";
		boolean corr = false; // can't check on the value of transpRGB
		String msg = "Enter a 6-digit Hexadecimal number representing the background colour. (eg: FFFFFF is pure white)";
		while(!corr){
			try{
				
				transpRGB = JOptionPane.showInputDialog(frame, msg, "Custom Background colour", JOptionPane.DEFAULT_OPTION);
				if(transpRGB == null){
					return; // cancel on cancel
				}
				corr = true;
				hex2dec(transpRGB); // test if the format is correct
				if(transpRGB.length()!=6){
					showError("You must enter exactly 6 digits");
					corr = false;
				}
			} catch(NumberFormatException nfex){
				showError("You can only enter a hexadecimal number");
				corr = false;
			}
		}
		setTranspBGColour(hex2dec(transpRGB));
	}
	
	// set the colour in the top-left pixel as the background-colour
	private void setTranspBGLT(){
		int argb = middleimage.getRGB(0, 0);
		String hexargb = dec2hex(argb);
		String rgb = hexargb.substring(2);
		setTranspBGColour(hex2dec(rgb));
	}
	
	private void setTranspBGColour(int col){
		transpCol = col;
		hasTranspBG = true;
		bgnone.setText("No Background");
		resetLabelIcon();
	}
	
	private void switchTranspBG(){
		hasTranspBG = !hasTranspBG;
		if(hasTranspBG){
			bgnone.setText("No Background");
		} else {
			bgnone.setText("A Background");
		}
		resetLabelIcon();
	}
	
	private void setAlpha(){
		int newAlpha = -1;
		String msg = "Enter an integer between 0 (exclusive) and 100 (inclusive). (eg: 100 = not transparent; 50 = half-transparent)";
		while(newAlpha == -1){
			try{
				String alphastr = JOptionPane.showInputDialog(frame, msg, "Custom Opacity", JOptionPane.DEFAULT_OPTION);
				if(alphastr == null)
					return; // cancel on cancel
				newAlpha = Integer.parseInt(alphastr);
				if(newAlpha > 100 || newAlpha < 1){
					showError("Please enter an Integer between 0 (exclusive) and 100 (inclusive).");
					newAlpha = -1;
				}
			
			}catch(NumberFormatException nfex){
				newAlpha = -1;
				showError("Invalid Format. You can only enter an Integer.");
			}
		}
		setAlpha(((float)newAlpha/100f));
	}
	
	private void setAlpha(float alpha){
		this.alpha = alpha;
		resetLabelIcon();
	}
	
	
	
	
	/**
	 * listen to the menu
	 */
	public void actionPerformed(ActionEvent e){
		if(e.getSource()==exititm){
			System.exit(-1);
		} else if(e.getSource()==loaditm){
			load();
		} else if(e.getSource()==saveitm){
			save();
		} else if(e.getSource()==copyitm){
			copy();
		} else if(e.getSource()==newitm){
			newIconDialog();
		} else if(e.getSource()==addtextitm){
			setIconText();
		} else if(e.getSource()==cleartextitm){
			clearText();
		} else if(e.getSource()==pasteimitm){
			pasteImage();
		} else if(e.getSource()==clearimitm){
			clearImage();
		} else if(e.getSource()==putimitm){
			putImage();
		} else if(e.getSource()==zoom1){
			if(middleimageZoom == 1){
				return;
			}
			decreaseZoom();
		} else if(e.getSource()==zoom2){
			if(middleimageZoom == 2){
				return;
			}
			increaseZoom();
		} else if(e.getSource()==centerimitm){
			centerImage();
		} else if(e.getSource()==bgmag){
			setTranspBGColour(0xFF00FF);
		} else if(e.getSource()==bgblk){
			setTranspBGColour(0x000000);
		} else if(e.getSource()==bgwht){
			setTranspBGColour(0xFFFFFF);
		} else if(e.getSource()==bgTL){
			setTranspBGLT();
		} else if(e.getSource()==bgcus){
			setTranspBGColour();
		} else if(e.getSource()==bgnone){
			switchTranspBG();
		} else if(e.getSource()==alpha100){
			setAlpha(1);
		} else if(e.getSource()==alpha75){
			setAlpha(0.75f);
		} else if(e.getSource()==alpha50){
			setAlpha(0.5f);
		} else if(e.getSource()==alpha25){
			setAlpha(0.25f);
		} else if(e.getSource()==alphacus){
			setAlpha();
		}
			
	}
	
	public void mouseEntered(MouseEvent ignore){}
	
	public void mouseExited(MouseEvent ignore){}
	
	public void mouseClicked(MouseEvent ignore){}
	
	public void mousePressed(MouseEvent e){
		int mousex = e.getX();
		int mousey = e.getY();
		if(middleimage==null)
			middleimageLoc = new Point(mousex, mousey);
		else{
			BufferedImage mImage = zoomTo(middleimage, middleimageZoom);
			middleimageLoc.setLocation(mousex - mImage.getWidth()/2, mousey - mImage.getHeight()/2);
		}
		resetLabelIcon();
		
	}
	
	public void mouseReleased(MouseEvent e){
		// ignore too?
	}
	
	public void mouseDragged(MouseEvent e) {
		mousePressed(e);
	}

	public void mouseMoved(MouseEvent ignore) {}
	

	
	public void keyPressed(KeyEvent ke) {
		int step = 2;
		if(ke.getModifiers()==ActionEvent.SHIFT_MASK)
			step = 4;
		else if(ke.getModifiers()==ActionEvent.CTRL_MASK)
			step = 1;
		
		if(ke.getKeyCode()==KeyEvent.VK_UP){
			middleimageLoc.y -= step;
			resetLabelIcon();
		} else if(ke.getKeyCode()==KeyEvent.VK_RIGHT){
			middleimageLoc.x += step;
			resetLabelIcon();
		} else if(ke.getKeyCode()==KeyEvent.VK_DOWN){
			middleimageLoc.y += step;
			resetLabelIcon();
		} else if(ke.getKeyCode()==KeyEvent.VK_LEFT){
			middleimageLoc.x -= step;
			resetLabelIcon();
		} else if(ke.getKeyCode()==KeyEvent.VK_ADD){
			increaseZoom();
		} else if(ke.getKeyCode()==KeyEvent.VK_SUBTRACT){
			decreaseZoom();
		}
			
	}

	public void keyReleased(KeyEvent ignore) {}

	public void keyTyped(KeyEvent ignore) {}
	
	/**
	 * Convenience method for showing a(n) (Error)MessageDialog using JOptionPane.
	 * @param message The Error-message to be shown
	 */
	private void showError(String message){
		JOptionPane.showMessageDialog(frame, message, "Error", JOptionPane.ERROR_MESSAGE);
	}

	public int hex2dec(String hex) throws NumberFormatException{
		return (int)Long.parseLong(hex,16);
	}
	
	public String dec2hex(int dec){
		String hex = Integer.toHexString(dec);
		return hex.length()==1 ? "0"+hex : hex;
	}

	private void printError(String error){
		if(!exported || exported)
			return;
		try{
			File errFile = new File("IMerrorlog.txt");
			StringBuffer errOut = new StringBuffer("");
			if(errFile.exists()){
				BufferedReader br = new BufferedReader(new FileReader(errFile));
				String currLine = br.readLine();
				while(currLine != null){
					errOut.append(currLine+"\n");
					currLine = br.readLine();
				}
				br.close();
			}
			long ctime = System.currentTimeMillis();
			Date cdate = new Date(ctime);
			SimpleDateFormat sdform = new SimpleDateFormat("yyyy.MMMMM.dd hh:mm");
			errOut.append("["+sdform.format(cdate)+"] "+error+"\n");
			
			BufferedWriter bw = new BufferedWriter(new FileWriter(errFile));
			bw.write(errOut.toString());
			bw.flush();
			bw.close();
			
		} catch(Exception ex){
			showError("An error occurred during the printing of another error that occurred.");
		}
	}
	
}
