import java.awt.datatransfer.DataFlavor;
import java.awt.datatransfer.Transferable;
import java.awt.datatransfer.UnsupportedFlavorException;
import java.awt.image.BufferedImage;


/**
 * ImageData container-class to store a BufferedImage on the clipboard
 * @author Nick Kraayenbrink / Barubary / Akatonbo
 * @since 09 dec 2007
 *
 */
public class ImageData implements Transferable{
	
	private BufferedImage data;
	
	public ImageData(BufferedImage data){
		this.data = data;		
	}
	
	public Object getTransferData(DataFlavor flavor) throws UnsupportedFlavorException {
		if (!isDataFlavorSupported(flavor)) {
			throw new UnsupportedFlavorException(flavor);
		}
		return data;
	}
	
	/**
	 * can only copy/paste images
	 */
	public DataFlavor[] getTransferDataFlavors() {
		return new DataFlavor[] {DataFlavor.imageFlavor };
	}
	
	/**
	 * can only copy/paste images
	 */
	public boolean isDataFlavorSupported(DataFlavor flavor) {
		return DataFlavor.imageFlavor.equals(flavor);
	}
	
	
	

}
